
PDZF / Z8X for Windows
====

Programed by Y.Taniuchi ( TAN-Y )

## About Z8X

FMP + PPZ8 であまっている PPZ8 チャンネルを、通常あまり使われない XYZ の FM3Extend パートを使って曲データから制御できるようにして、演奏機能を拡張してしまおう、
という常駐プログラム「でした」。

## About PDZF

Z8Xと基本コンセンプトが同じですが、機能を大幅に強化した上位ソフトです。
FM3Extendの他、SSGパート、リズムパートもPPZ8パートして使用することができ、LFOの多くの波形やピッチベンドにも対応。他、多くの機能が拡張されています。

骨折飲料氏が開発しました。


## About PDZF / Z8X for Windows

PDZF,Z8XをC60氏作、WinFMPと組み合わせて使用できるようにした追加DLLです。
このDLLを組み合わせることで、Windows上でFMP + PPZ8 + PDZF or Z8Xを使用した曲データの演奏が可能になります。
プレイヤーソフトはWinFMP.dllに対応していれば OK です。

実装形態としては、「Z8X」と「PDZFのエンハンストモード」となっています。
まあPDZFのスタンダードモード＝Z8Xなんですけどね・・・


## Structure

Ver.1.x 系は WinFMP とアプリケーションの間に独自に割り込む形で実装をしていました。

Ver.2.0 以降の PDZFZ8XWin では構造が改められ、WinFMP の拡張機能として動作します。
WinFMP から PDZFZ8XWin を使う、という形になっています。


## Requried Softwares

* WinFMP.dll Ver.0.18 以降
* Visual C++ 2022 ランタイム(x86 / x64)
* WinFMP対応プレイヤー(FMPMD.exeなど)

開発環境が VC++2022 になったので、Windows XP 以前では動作しなくなりました。


## Setup

WinFMP.dll　と同じディレクトリに PDZFZ8XWin.dll をコピーしてください。


## How to play

普通にプレイヤーでPDZF、Z8X対応データを演奏させてください。


## About API

Ver.1.x 系では WinFMP を独自に拡張していたので、取得した WinFMP のインスタンスに対して QueryInterface で IPDZFZ8X インターフェースを取得する形でした。

Ver.2.x 系では WinFMP Ver.0.18 以降で拡張された API から取得する必要があります。
詳細は WinFMP のドキュメント及び PDZFZ8XWin の API ドキュメントを参照してください。


## Difference from PC-98 Version

* Z8X
  * オリジナルではエンベロープとLFOのカウントの取り方を間違っていました
  * 1カウント分、ウエイトが短くなってたみたいです。直して実装しました。
* PDZF
  * MRの第4パラメータが0～3以外の値だと、MRの処理自体をスキップしてしまうのですが、0の値がセットされているものとして処理するようにしました
  * デチューン値による補正周波数値の計算がデチューンパラメータの変更時にしか行っていなかったのですが、オクターブが変わった時に正しい補正値にならなくなってしまうので、毎回再計算するようにしました


## Limitation

PDZFZ8XWin をインストールするとデフォルトで有効になり、アプリケーションで制御しないと動作中に無効にすることはできません。


## License

このソフトはフリーソフトです。
著作権は谷内靖弘 (TAN-Y) にあります。
PDZF 対応の際に、骨折飲料氏よりオリジナル版のソースの提供をしていただき、そのコードを C++ に移植することで対応しました。

このソフトを利用する場合、利用者の責任で行ってください。不具合等が発生してもこちらで対応する義務はありません。

転載、不特定多数に対する再配布等は原則、禁止します。
必要以上な金銭を伴わない配布はご自由に。その際、中身の変更はしないでください。


## Contact

何かありましたらこちらまで。

http://www.aosoft.jp/


## Special thanks

WinFMP と PMDWin の作者である C60 さん。

fmgen の作者である cisc. さん。

PDZF のオリジナル版の作者である骨折飲料さん。ソース提供の他、動作チェックにも協力していただきました。

ありがとうございました。


## Release Notes

* Ver.2.0.1 (2023/3/8)
  * Visual Studio 2022 に移行
  * x64 ビルド対応
  * コード整理
    * ソースコードの UTF-8 化
    * 実装の変更はなし
* ver.2.0.0 (2012/1/22)
  * WinFMP から制御を受ける形に構造を一新した
* ver.1.2.0 (2011/10/6(非公開版))
  * Visual Studio 2008 に移行
  * その他バグ修正
* ver.1.1.0 (2003/10/28)
  * PPZ8 ミックス時のリサンプルのバグ修正
  * オリジナルとの互換性を向上させた (Mamiya 氏作 Winamp プラグイン「inFMPMD(in_pmd.dll)」とDDTOM氏作「FMPP」でも鳴るようになりました)
  * オリジナルのWinFMPのDLL配置位置をPDZFZ8X.dllと同じ位置に置いて読めるように修正（今までだと実質的にはWinFMPを使うアプリのDLL読み込みパスを検索していた）
  * PDZFZ8X の 独自APIを追加したけど未確認
  * シーケンス処理タイミングが1クロックずれてたっぽいので修正
  * getmusicfilenameで曲データ名が取得できるように修正
  * (Z8X)キーオフ判定をPDZF準拠にした(FMPP対策)
* Ver.1.0.1 (2003/8/23)
  * PDZF エンハンストモードを実装名前を PDZFZ8XWin に変更
  * (Z8X) LFO 処理をオリジナルのバグと思ってたのが、バグではなかったので修正
  * 同名のPVIを使った曲をロードしようとするとエラーになる場合があるのを修正
* Ver.1.0.0 (2003/8/4)
  * 初版 (一通りの機能は実装した「はず」)








